//SETUP USING BELOW VARS....
var maxZoom = 5;
var tutorial_step = 1;
var totalSteps = 12;
var tutorialSteps = 5; //top message introduction tutorial total steps.
var totalQuestions = 9;
var totalAgreeQuestions = 2;
var totalOrderQuestions = 1;
var help = 1; // will switch to help = 2 for the second part etc...

var currentQuestion = currentAgreeQuestion = currentOrderQuestion = 1;
var svglandfill;
var currentZoom;
var initialZoom;
var svg;
var stepHotspots;
var seenHotspots;
var neverNotifyAboutUnseen = false;
var correctAnswers;
var answeredCorrect;


var hotspotdata = (function() {
    var json = null;
    $.ajax({
        'async': false,
        'global': false,
        'url': "js/hotspot-info.json",
        'dataType': "json",
        'success': function (data) {
            json = data;
        }
    });
    return json;
})();

var questiondata = (function() {
    var json = null;
    $.ajax({
        'async': false,
        'global': false,
        'url': "js/questions.json",
        'dataType': "json",
        'success': function (data) {
            json = data;
        }
    });
    return json;
})();

var step = 0;

var trashtruckanimation = false;
var trashpatchshown = false;
var animatedbirds = false;
var animatedclouds = false;

$(window).load(function() {

    $('#landfill-container').svg({loadURL: 'assets/landfill.svg', onLoad: setupSVGhandlers})

});

$(document).ready(function(){

    introMessage();

    tippy('[data-tippy-content]');

    setTimeout(function(){
        window.dispatchEvent(new Event('resize'));
    }, 500);

    swal({
      icon: 'info',
      title: 'Πλήρης Οθόνη;',
      text: 'Μήπως θα ήθελες να ανοίξεις τον ΧΥΤΑ σε λειτουργία πλήρους οθόνης; Θα είναι περισσότερο απολαυστικό!',
      buttons: {
        confirm: {
          text: "Ναι! Τέλεια ιδέα!",
          value: true,
          visible: true,
          className: "go-fullscreen-ok",
          closeModal: true
        },
        cancel: {
          text: "Όχι...",
            value: null,
            visible: true,
            className: "go-fullscreen-cancel",
            closeModal: true,
        }
      }
    }).then(function(result) {
        if(result){
          if (screenfull.enabled) {
            screenfull.request();
          }
        }
    });

    $('#fullscreen-toggle').click(function(){
       if(screenfull.isFullscreen){
           screenfull.exit();
       } else {
           if (screenfull.enabled) {
               screenfull.request();
           }
       }
    });

    $('#info-button').click(function(){
        var html = '<div class="iframe-container">\n' +
          '        <div class="close-iframe"><img src="assets/close.svg" class="close-button-x"></div>\n' +
          '        <iframe src="info.html" class="info-iframe"></iframe>\n' +
          '    </div>';
        $('.svg-container').append(html);

        $('.close-iframe').click(function(){
           $('.iframe-container').remove();
        });
    });

    $('#help-button').click(function(){

        var topMessageExists = $('.top-message').length > 0;

        if (!topMessageExists) {
            switch (help) {
                case 1:
                    introMessage();
                    //initialize controls for top message owl carousel
                    initTopMessage();
                    break;
                case 2:
                    hotspotsHelp();
                    break;
                case 3:
                    agreeHelp();
                    break;
                case 4:
                    orderHelp();
                default:
                    break;
            }
        }
    });

    $('#prev-button').click(function() {

        if (step === 0)
            return;

        $('.hotspot-popup').remove();
        if (stepHotspots - seenHotspots > 0 && !neverNotifyAboutUnseen) {
            swal({
              icon: 'warning',
              title: 'Μήπως σου ξέφυγε κάτι;',
              text: 'Δεν έχεις εξερευνήσει όλες τις ενεργές περιοχές... Θέλεις σίγουρα να συνεχίσεις χωρίς να δεις όλες τις περιοχές; Επάνω αριστερά μπορείς να δεις πόσες περιοχές δεν έχεις εξερευνήσει.',
              buttons: {
                confirm: {
                  text: "Όχι, Θα ψάξω καλύτερα...",
                  value: 0,
                  visible: true,
                  className: "alert-see-hotspots",
                  closeModal: true
                },
                cancel: {
                  text: "Ναι, θέλω να συνεχίσω!",
                    value: 1,
                    visible: true,
                    className: "alert-move-next",
                    closeModal: true,
                },
                never: {
                    text: "Να μην εμφανιστεί ξανά αυτό το μήνυμα",
                    value: 2,
                    visible: true,
                    className: "alert-never",
                    closeModal: true
                }
              }
            }).then(function(result) {

                setTimeout(function(){
                    $('#hotspots-info').addClass('animated tada');
                },200);
                setTimeout(function(){
                    $('#hotspots-info').removeClass('animated tada');
                }, 2000);

                if(result === 1){
                    movePrev();
                } else if (result == 2){
                    neverNotifyAboutUnseen = true;
                } else { // decided to look more...
                    if (step === 5) { // the monitoring system...
                        svglandfill.pan({x: -1800, y: 454});
                    }
                }
            });
        } else if (stepHotspots - seenHotspots > 0 && neverNotifyAboutUnseen){
            setTimeout(function(){
                $('#hotspots-info').addClass('animated tada');
            },200);
            if (step === 5) { // the monitoring system...
                svglandfill.pan({x: -1800, y: 454});
            }
            setTimeout(function(){
                $('#hotspots-info').removeClass('animated tada');
                movePrev();
            }, 1800);
        } else {
            movePrev();
        }
    });

    $('#next-button').click(function() {

        if (step === totalSteps)
            return;

        $('.hotspot-popup').remove();
        if (stepHotspots - seenHotspots > 0 && !neverNotifyAboutUnseen) {
            swal({
              icon: 'warning',
              title: 'Μήπως σου ξέφυγε κάτι;',
              text: 'Δεν έχεις εξερευνήσει όλες τις ενεργές περιοχές... Θέλεις σίγουρα να συνεχίσεις χωρίς να δεις όλες τις περιοχές; Επάνω αριστερά μπορείς να δεις πόσες περιοχές δεν έχεις εξερευνήσει.',
              buttons: {
                confirm: {
                  text: "Όχι, Θα ψάξω καλύτερα...",
                  value: 0,
                  visible: true,
                  className: "alert-see-hotspots",
                  closeModal: true
                },
                cancel: {
                  text: "Ναι, θέλω να συνεχίσω!",
                    value: 1,
                    visible: true,
                    className: "alert-move-next",
                    closeModal: true,
                },
                never: {
                    text: "Να μην εμφανιστεί ξανά αυτό το μήνυμα",
                    value: 2,
                    visible: true,
                    className: "alert-never",
                    closeModal: true
                }
              }
            }).then(function(result) {

                setTimeout(function(){
                    $('#hotspots-info').addClass('animated tada');
                },200);
                setTimeout(function(){
                    $('#hotspots-info').removeClass('animated tada');
                }, 2000);

                if(result === 1){
                    moveNext();
                } else if (result == 2){
                    neverNotifyAboutUnseen = true;
                } else { // decided to look more...
                    if (step === 5) { // the monitoring system...
                        svglandfill.pan({x: -1800, y: 454});
                    }
                }
            });
        } else if (stepHotspots - seenHotspots > 0 && neverNotifyAboutUnseen){
            setTimeout(function(){
                $('#hotspots-info').addClass('animated tada');
            },200);
            if (step === 5) { // the monitoring system...
                svglandfill.pan({x: -1800, y: 454});
            }
            setTimeout(function(){
                $('#hotspots-info').removeClass('animated tada');
                moveNext();
            }, 1800);
        } else {
            moveNext();
         }
    });

    //initialize top message owl carousel
    initTopMessage();

    $('.button-questions').click(function(){
        $(this).remove();
        help = 2; // switch to the second help page...
        $('.hotspot-popup').remove();
        hideElement('g#i12-1');
        showInitialQuestion();
        $('.prev-next-buttons').remove();
    });
});

function moveNext() {
    if (step < totalSteps) {
        step ++;
        nextHotspots(step);
    }
}

function movePrev() {
    if (step > 0) {
        step --;
        nextHotspots(step);
    }
}

function nextHotspots(step){
    seenHotspots = 0;
    switch (step) {
        case 0:

            if (!animatedclouds) {
                animatedclouds = true;
                $('g#clouds').attr('display', '').addClass('cloud-anim');
            }

            stepHotspots = 3;
            showHotspot('g#i0-1');
            showHotspot('g#i0-2');
            showHotspot('g#i1-1'); // has moved to first slide

            // hideElement('g#i1-1');
            hideElement('g#i1-2');
            hideElement('g#i1-3');
            hideElement('g#i1-4');
            $('g#s0-initial').attr('display','');
            $('g#s1-fence').attr('display','none');
            $('g#s1-control').attr('display', 'none');
            $('g#s1-dirt').attr('display', 'none');
            break;
        case 1:
            stepHotspots = 3;
            hideElement('g#i1-1'); // will be hidden as it has moved to previous

            showHotspot('g#i1-2');
            showHotspot('g#i1-3');
            showHotspot('g#i1-4');

            hideElement('g#i0-1');
            hideElement('g#i0-2');
            hideElement('g#i2-1');
            hideElement('g#i2-2');

            if (!animatedclouds) {
                animatedclouds = true;
                $('g#clouds').attr('display', '').addClass('cloud-anim');
            }

            $('g#s0-initial').attr('display','none');
            $('g#s1-fence').attr('display','');
            $('g#s1-control').attr('display', '');
            $('g#s1-dirt').attr('display', '');
            $('g#s2-extra-trees').attr('display','none');
            $('g#s2-compact-clay').attr('display', 'none');
            break;
        case 2:
            stepHotspots = 2;
            hideElement('g#i1-1');
            hideElement('g#i1-2');
            hideElement('g#i1-3');
            hideElement('g#i1-4');

            showHotspot('g#i2-1');
            showHotspot('g#i2-2');

            hideElement('g#i3-1');
            $('g#s2-compact-clay').attr('display','');
            $('g#s2-extra-trees').attr('display','');
            $('g#s3-geomembrabe').attr('display','none');
            break;
        case 3:
            stepHotspots = 1;
            hideElement('g#i2-1');
            hideElement('g#i2-2');

            showHotspot('g#i3-1');

            hideElement('g#i4-1');
            hideElement('g#i4-2');
            hideElement('g#i4-3');
            hideElement('g#i4-4');
            $('g#s3-geomembrabe').attr('display','');
            $('g#s4-fluids').attr('display','none');
            $('g#s4-collection-layer').attr('display','none');
            $('g#s4-collection-unit').attr('display','none');
            $('g#s4-1-hydrants').attr('display', 'none');
            break;
        case 4:
            stepHotspots = 4;
            hideElement('g#i3-1');

            showHotspot('g#i4-1');
            showHotspot('g#i4-2');
            showHotspot('g#i4-3');
            showHotspot('g#i4-4');

            hideElement('g#i5-1');
            hideElement('g#i5-2');
            $('g#s4-fluids').attr('display','');
            $('g#s4-collection-layer').attr('display','');
            $('g#s4-collection-unit').attr('display','');
            $('g#s4-1-hydrants').attr('display', '');
            $('g#s5-monitoring-system').attr('display','none');
            break;
        case 5:
            stepHotspots = 2;
            hideElement('g#i4-1');
            hideElement('g#i4-2');
            hideElement('g#i4-3');
            hideElement('g#i4-4');

            showHotspot('g#i5-1');
            showHotspot('g#i5-2');

            hideElement('g#i6-1');
            $('g#s5-monitoring-system').attr('display','');
            $('g#s6-scale').attr('display','none');

            svglandfill.pan({x: -1800, y: 454}); // trick to move to the spot

            break;
        case 6:
            stepHotspots = 1;
            hideElement('g#i5-1');
            hideElement('g#i5-2');

            showHotspot('g#i6-1');

            hideElement('g#i7-1');
            $('g#s6-scale').attr('display','');
            $('g#s7-bring-trash').attr('display','none');
            break;
        case 7:
            stepHotspots = 1;
            hideElement('g#i6-1');

            showHotspot('g#i7-1');

            hideElement('g#i8-1');

            var trashtruck = $('g#s7-bring-trash');
            trashtruck.attr('display','');

            if (!trashtruckanimation) {
                trashtruckanimation=true;
                trashtruck.addClass('moveToScale');
                setTimeout(function(){
                    $('g#needle').addClass('moveNeedleScale');
                },2300);
            }

            if (trashpatchshown) {
                $('g#s8-1-trash-patch').attr('display', 'none');
            }

            $('g#s8-unload').attr('display','none');
            break;
        case 8:
            stepHotspots = 1;
            hideElement('g#i7-1');

            showHotspot('g#i8-1');

            hideElement('g#i9-1');
            hideElement('g#i9-2');
            hideElement('g#i9-3');

            $('g#bucket').addClass('liftBucket');
            $('polygon#rod').addClass('moveRod');
            setTimeout(function(){
                $('g#trash').addClass('falling-trash');
            }, 2000);
            if (trashpatchshown) {
                $('g#s8-1-trash-patch').attr('display', '');
            } else { //will animate the trash falling and show the patch with delay...
                trashpatchshown = true;
                setTimeout(function(){
                    $('g#s8-1-trash-patch').attr('display', '').addClass('fadeIn');
                }, 3000);
            }

            $('g#s8-unload').attr('display','');
            $('g#s7-bring-trash').attr('display', 'none');
            $('g#s9-compact-trash').attr('display','none');
            $('g#s9-compacted-trash').attr('display','none');
            $('g#s9-compacted-cells').attr('display','none');
            $('g#s9-1-bird-static').attr('display', 'none');
            break;
        case 9:
            stepHotspots = 3;
            hideElement('g#i8-1');

            showHotspot('g#i9-1');
            showHotspot('g#i9-2');
            showHotspot('g#i9-3');

            hideElement('g#i10-1');
            hideElement('g#i10-2');
            hideElement('g#i10-3');

            $('#compactor-fr-wheel, #compactor-r-wheel').addClass('rotate-compactor-wheels');
            $('#compactor-chassis').addClass('compactor-forward');

            if (!animatedbirds) {
                animatedbirds = true;
                $('g#s9-1-bird1').attr('display', '').addClass('bird1-anim');
                $('g#s9-1-bird2').attr('display', '').addClass('bird2-anim');
                $('g#s9-1-bird3').attr('display', '').addClass('bird3-anim');
            }

            $('g#s9-compact-trash').attr('display','');
            $('g#s9-compacted-trash').attr('display','');
            $('g#s9-compacted-cells').attr('display','');
            $('g#s9-1-bird-static').attr('display', '');
            $('g#s10-pipes').attr('display','none');
            $('g#s10-power-grid').attr('display','none');
            break;
        case 10:
            stepHotspots = 3;
            hideElement('g#i9-1');
            hideElement('g#i9-2');
            hideElement('g#i9-3');

            showHotspot('g#i10-1');
            showHotspot('g#i10-2');
            showHotspot('g#i10-3');

            hideElement('g#i11-1');
            $('g#s10-pipes').attr('display','');
            $('g#s10-power-grid').attr('display','');

            $('g#s1-control').attr('display','');
            $('g#s1-dirt').attr('display','');
            $('g#s4-fluids').attr('display','');
            $('g#s4-collection-unit').attr('display','');
            // $('g#s4-collection-layer').attr('display','');
            $('g#s4-1-hydrants').attr('display', '');
            $('g#s6-scale').attr('display','');
            $('g#s8-unload').attr('display','');
            $('g#s8-1-trash-patch').attr('display', '');
            $('g#s9-compact-trash').attr('display','');
            // $('g#s9-compacted-trash').attr('display','');
            // $('g#s9-compacted-cells').attr('display','');
            $('g#s10-pipes').attr('display','');
            $('g#s10-power-grid').attr('display','');
            $('g#s9-1-bird-static').attr('display','');

            $('g#s11-closed').attr('display','none');
            $('g#s11-closed-cells-back').attr('display','none');

            break;
        case 11:
            stepHotspots = 1;
            hideElement('g#i10-1');
            hideElement('g#i10-2');
            hideElement('g#i10-3');

            showHotspot('g#i11-1');

            hideElement('g#i12-1');
            $('g#s11-closed').attr('display','');
            $('g#s11-closed-cells-back').attr('display','');
            $('g#s1-fence').attr('display','');

            $('g#s1-control').attr('display','none');
            $('g#s1-dirt').attr('display','none');
            $('g#s4-fluids').attr('display','none');
            $('g#s4-collection-unit').attr('display','none');
            // $('g#s4-collection-layer').attr('display','none');
            $('g#s4-1-hydrants').attr('display', 'none');
            $('g#s6-scale').attr('display','none');
            $('g#s8-unload').attr('display','none');
            $('g#s8-1-trash-patch').attr('display', 'none');
            $('g#s9-compact-trash').attr('display','none');
            // $('g#s9-compacted-trash').attr('display','none');
            // $('g#s9-compacted-cells').attr('display','none');
            $('g#s9-1-bird-static').attr('display','none');
            $('g#s10-pipes').attr('display','none');
            $('g#s10-power-grid').attr('display','none');
            $('g#s12-restoration').attr('display','none');
            $('.button-questions').addClass('hidden');
            break;
        case 12:
            stepHotspots = 1;
            showHotspot('g#i12-1');
            hideElement('g#i11-1');
            $('g#s1-fence').attr('display','none');
            $('g#s12-restoration').attr('display','');
            $('.button-questions').removeClass('hidden');
            break;
        default:
    }
}

function showHotspot(element){
    var el = $(element);
    el.attr('display','');
    if (!el.hasClass('seen')) {
        el.addClass('custom-animated infinite custom-pulse');
    } else {
        seenHotspots ++;
    }
    if (!el.hasClass('bound')){
        el.addClass('bound');
        el.click(function(){
            if (!el.hasClass('seen')){
                el.addClass('seen');
                seenHotspots ++;
            }
            el.removeClass('custom-animated infinite custom-pulse');
            $('.hotspots-no').html(stepHotspots - seenHotspots);
            showHotspotInfo(element);
        });
    }
    $('.hotspots-no').html(stepHotspots - seenHotspots);
}

function hideElement(element) {
    var el = $(element);
    el.attr('display', 'none');
}

function showElement(element) {
    var el = $(element);
    el.attr('display', '');
}

function showHotspotInfo(element){

    var image = '<div style="padding-top: 20px;"></div>';
    var hasimage = hotspotdata[element].image !== '';

    if (hasimage){
        var imagename = hotspotdata[element].image;
        // image = '<img class="top-image" src="images/'+hotspotdata[element].image+'"/>';
        image = ''+
        '<div class="col-lg-6">' +
        '    <a class="popup-image-link" href="images/' + imagename + '.jpg" data-lightbox="' + imagename + '">' +
        '       <img class="popup-image" src="images/' + imagename + '-small.jpg" alt="' + imagename + '" />' +
        '       <div class="zoom-text">μεγέθυνση εικόνας</div>' +
        '    </a>' +
        '</div>';
    }

    var spanning = '';

    if (hasimage) {
      spanning = 'col-lg-6';
    } else {
      spanning = 'col-lg-12';
    }

    var text = hotspotdata[element].text;
    var title = hotspotdata[element].title;

    var hotspotInfo = ''+
    '<div class="hotspot-popup">'+
    '   <div class="close-popup">'+
    '       <img src="assets/close.svg" class="close-button-x">'+
    '   </div>' +
    '   <div class="row">' + image +
    '      <div class="' + spanning + ' text">' +
    '          <div class="popup-title">' + title + '</div><hr>' +
    '          <p>' + text + '</p>' +
    '      </div>' +
    '   </div>' +
    '</div>';

    $('body').append(hotspotInfo);
    $('.close-popup').click(function(){
        $('.hotspot-popup').remove();
    });

    // if (step == totalSteps) {
    //     $('.button-questions').click(function(){
    //         help = 2; // switch to the second help page...
    //         $('.hotspot-popup').remove();
    //         hideElement('g#i12-1');
    //         showInitialQuestion();
    //         $('.prev-next-buttons').remove();
    //     });
    // }
}

function initializeTippyContent() {
    $('g#a1-1').attr('data-tippy-content', 'περιμετρικά δέντρα και άλλα φυτά');
    $('g#a1-2').attr('data-tippy-content', 'καθημερινή κάλυψη απορριμμάτων');
    $('g#a2-1').attr('data-tippy-content', 'διασταλλάζοντα υγρά');
    $('g#a3-1').attr('data-tippy-content', 'πλαστικές μεμβράνες στεγανοποίησης');
    $('g#a3-2').attr('data-tippy-content', 'δίκτυο σωλήνων συλλογής διασταλλαζόντων υγρών');
    $('g#a3-3').attr('data-tippy-content', 'μονάδα επεξεργασίας υγρών αποβλήτων');
    $('g#a4-1').attr('data-tippy-content', 'βιοαέριο');
    $('g#a5-1').attr('data-tippy-content', 'δίκτυο σωλήνων συλλογής βιοαερίου');
    $('g#a6-1').attr('data-tippy-content', 'μονάδα παραγωγής ηλεκτρισμού από καύση βιοαερίου');
    $('g#a7-1').attr('data-tippy-content', 'περίφραξη');
    $('g#a8-1').attr('data-tippy-content', 'ζύγισμα απορριμμάτων');

    tippy('[data-tippy-content]');
}

function showInitialQuestion() {
    var html = '' +
    '<div class="question-container">' +
        '<div class="question-text"></div>' +
        '<div class="correct-answers">Περιοχές που πρέπει να βρεις: <span></span></div>' +
        // '<div class="button next-question">Επόμενη Ερώτηση</div>' +
    '</div>';

    $('body').append(html);
    showQuestion('q1');

    // hide unecessary UI elements
    $('#hotspots-info, .next-prev-buttons').remove();

    // get landfill to the correct state..
    $('g#s10-pipes').attr('display','');
    $('g#s10-power-grid').attr('display','');
    $('g#s1-fence').attr('display','');
    $('g#s1-control').attr('display','');
    $('g#s1-dirt').attr('display','');
    $('g#s4-fluids').attr('display','');
    $('g#s4-collection-unit').attr('display','');
    $('g#s4-1-hydrants').attr('display', '');
    $('g#s6-scale').attr('display','');
    $('g#s7-bring-trash').attr('display','');
    $('g#s8-1-trash-patch').attr('display', '');
    $('g#s9-compact-trash').attr('display','');
    $('g#s10-pipes').attr('display','');
    $('g#s10-power-grid').attr('display','');
    $('g#s9-1-bird-static').attr('display','');

    $('g#s11-closed').attr('display','none');
    $('g#s11-closed-cells-back').attr('display','none');
    $('g#s12-restoration').attr('display','none');

    showQuestionHotspot('g#a1-1');
    showQuestionHotspot('g#a1-2');
    showQuestionHotspot('g#a2-1');
    showQuestionHotspot('g#a3-1');
    showQuestionHotspot('g#a3-2');
    showQuestionHotspot('g#a3-3');
    showQuestionHotspot('g#a4-1');
    showQuestionHotspot('g#a5-1');
    showQuestionHotspot('g#a6-1');
    showQuestionHotspot('g#a7-1');
    showQuestionHotspot('g#a8-1');
}

function showQuestion(question){

    var q = questiondata.hotspot_questions;

    var text = q[question].text;
    var ans = q[question].answers;
    correctAnswers = ans.length;
    answeredCorrect = 0;

    $('.question-text').html(text);
    $('.correct-answers span').html(correctAnswers - answeredCorrect);

    //marking the correct answers
    for (var i = 0; i < ans.length; i++) {
        $('g#'+ans[i])
        .addClass('correct');
    }

}

function showQuestionHotspot(element){
    var el = $(element);
    el.attr('display','');
    el.addClass('custom-animated infinite custom-pulse');
    el.click(function(){
        if (el.hasClass('correct')) {
            el.remove();
            answeredCorrect ++;
            if (correctAnswers == answeredCorrect) {
                // must move to next question
                currentQuestion ++;
                if (currentQuestion < totalQuestions) {
                    swal('Τέλεια!', 'Βρήκες όλα τα σημεία για αυτή την ερώτηση. Φύγαμε για την επόμενη...' , 'success')
                    .then(function(){
                        showQuestion('q'+currentQuestion);
                    });
                } else {
                    swal(
                        'Συγχαρητήρια!',
                        'Βρήκες όλα τα σημεία για να απαντήσεις σε όλες τις ερωτήσεις προβληματισμού. Ακολουθούν 2 ερωτήσεις στις οποίες θα πρέπει να απαντήσεις αν συμφωνείς ή διαφωνείς.' ,
                        'success'
                    ).then(function(response){
                        help = 3; // switch the help page...
                        showQuestionAgree(currentAgreeQuestion);
                    });
                }
            } else {
                var remaining = correctAnswers - answeredCorrect;
                if (remaining > 1){
                    swal('Τέλεια!', 'Το βρήκες! Έμειναν ' + remaining + ' σημεία...' , 'success');
                } else {
                    swal('Τέλεια!', 'Το βρήκες! Έμεινε μόνο 1 σημείο...' , 'success');
                }
            }
        } else {
            swal('Ουπς...', 'Δεν είναι αυτό το σωστό σημείο.. Σκέψου και ψάξε καλύτερα...', 'error');
        }
        $('.correct-answers span').html(correctAnswers - answeredCorrect);
    });
}

function showQuestionAgree(question) {
    $('.correct-answers, .agree-buttons').remove();

    var q = questiondata.agree_questions['q' + question];
    $('.question-text').html(q.text);

    var answerButtons = ''+
    '<div class="agree-buttons">' +
        '<div class="agree">Συμφωνώ</div>' +
        '<div class="disagree">Διαφωνώ</div>' +
    '</div>'

    $('.question-container').append(answerButtons);
    $('.agree').click(function(){
        swal('', q.agree, 'info')
        .then(function(){
            currentAgreeQuestion++;
            if (currentAgreeQuestion > totalAgreeQuestions){
                help = 4; // switch the help page...
                showOrderQuestion(currentOrderQuestion);
            } else {
                showQuestionAgree(currentAgreeQuestion);
            }
        });
    });
    $('.disagree').click(function(){
        swal('', q.disagree, 'info')
        .then(function(){
            currentAgreeQuestion++;
            if (currentAgreeQuestion > totalAgreeQuestions){
                help = 4; // switch the help page...
                showOrderQuestion(currentOrderQuestion);
            } else {
                showQuestionAgree(currentAgreeQuestion);
            }
        });
    });
}

function showOrderQuestion(question) {
    var q = questiondata.order_questions['q' + question];
    var options = q.options;

    $('.agree-buttons, .order-container').remove();

    $('.question-text').html(q.text);

    var order_container = '' +
    '<div class="order-container">' +
        '<div class="q-option" data-option-no="3"><div class="option">' + options[2] + '</div><div class="input" data-input-option="3"><input maxlength="1" type="text" name="opt3" placeholder="Συμπλήρωσε 1, 2 ή 3"></div></div>' +
        '<div class="q-option" data-option-no="1"><div class="option">' + options[0] + '</div><div class="input" data-input-option="1"><input maxlength="1" type="text" name="opt1" placeholder="Συμπλήρωσε 1, 2 ή 3"></div></div>' +
        '<div class="q-option" data-option-no="2"><div class="option">' + options[1] + '</div><div class="input" data-input-option="2"><input maxlength="1" type="text" name="opt2" placeholder="Συμπλήρωσε 1, 2 ή 3"></div></div>' +
        '<div class="submit-answers">Καταχώρηση Απαντήσεων</div>' +
    '</div>';

    $('.question-text').append(order_container);
    $('.submit-answers').click(function(){
        var option1 = parseInt($('[data-option-no="1"] input').val()) === 1
        var option2 = parseInt($('[data-option-no="2"] input').val()) === 2
        var option3 = parseInt($('[data-option-no="3"] input').val()) === 3
        if (option1 && option2 && option3) {
            swal({
                title: 'Συγχαρητήρια!',
                text: 'Έχεις ολοκληρώσει με επιτυχία όλες τις δραστηριότητες!',
                icon: 'success',
                closeOnClickOutside: false,
                closeOnEsc: false,
                buttons: false
            });
        } else {
            swal('Χμμμ...', 'Μάλλον θα πρέπει να σκεφτείς καλύτερα την προτεραιότητα των ενεργειών που θα πρέπει να κάνεις ώστε να περιορίσουμε σημαντικά την ανάγκη για κατασκευή Χώρων Υγειονομικής Ταφής Απορριμμάτων', 'error');
        }
    });
}

function setupSVGhandlers(){

    // setup tippy after the svg has loaded
    initializeTippyContent();

    $('#landfill').attr('width','100%').attr('height', '100%');

    initializeFrameZoomPan();

    $('#svg-pan-zoom-zoom-in').on('click', function(){
        if (currentZoom < maxZoom) {
            currentZoom += 0.5;
            svglandfill.zoom(currentZoom);
        }
    });
    $('#svg-pan-zoom-zoom-out').on('click', function(){
        if (currentZoom < maxZoom) {
            currentZoom -= 0.5;
            svglandfill.zoom(currentZoom);
        }
    });
    $('#svg-pan-zoom-reset-pan-zoom').on('click', function(){
        currentZoom = 1;
        svglandfill.reset();
    });

    $(window).resize(function(){
        svglandfill.resize();
        svglandfill.fit();
        svglandfill.center();
    });

    svg = $('.hasSVG').svg('get');
}

function initTopMessage(){
  var owl = $(".top-message-carousel")

  owl.owlCarousel({
    // animateOut: 'fadeOut',
    // animateIn: 'fadeIn',
    items:1,
    margin:30,
    stagePadding:30,
    smartSpeed:450
  });

  tutorial_step = 1;

  $('.button-next').click(function(){
    owl.trigger('next.owl.carousel');
    tutorial_step ++;
    if(tutorial_step>1){
      $('.button-prev').removeClass('is_hidden');
      if(tutorial_step === tutorialSteps - 1 ){
        $('.button-next .button-text').text('ΤΕΛΟΣ');
      }
    }
    if(tutorial_step === tutorialSteps){
      $('.top-message').addClass('fadeOut faster').delay(1000).queue(function(next) {
        $(this).remove();
        // next();
        nextHotspots(step);
      });
    }
  });

  $('.button-prev').click(function(){
    owl.trigger('prev.owl.carousel');
    tutorial_step --;
    if(tutorial_step === 1){
      $('.button-prev').addClass('is_hidden');
    }
    if(tutorial_step !== tutorialSteps - 1) {
      $('.button-next .button-text').text('ΕΠΟΜΕΝΟ');
    }
  });
}

function initializeFrameZoomPan(){
    //to limit the panning to always contain the graphics
    var beforePan;

    beforePan = function(oldPan, newPan){

        var stopHorizontal = false
            , stopVertical = false
            , gutterWidth = $(window).width()
            , gutterHeight = $(window).height()
            // Computed variables
            , sizes = this.getSizes()
            , leftLimit = -((sizes.viewBox.x + sizes.viewBox.width) * sizes.realZoom) + gutterWidth
            , rightLimit = sizes.width - gutterWidth - (sizes.viewBox.x * sizes.realZoom)
            , topLimit = -((sizes.viewBox.y + sizes.viewBox.height) * sizes.realZoom) + gutterHeight
            , bottomLimit = sizes.height - gutterHeight - (sizes.viewBox.y * sizes.realZoom);

        customPan = {};
        customPan.x = Math.max(leftLimit, Math.min(rightLimit, newPan.x));
        customPan.y = Math.max(topLimit, Math.min(bottomLimit, newPan.y));

        return customPan;
    };


    svglandfill = svgPanZoom('#landfill', {
        viewportSelector: '.svg-pan-zoom_viewport'
        , panEnabled: true
        , controlIconsEnabled: false
        , zoomEnabled: true
        , dblClickZoomEnabled: false
        , mouseWheelZoomEnabled: true
        , preventMouseEventsDefault: true
        , zoomScaleSensitivity: 0.2
        , minZoom: 1
        , maxZoom: maxZoom
        , fit: false
        , contain: true
        , center: true
        , refreshRate: 'auto'
        , beforePan: beforePan
//            , beforeZoom: function(){}
//            , onZoom: function(){}
//            , beforePan: function(){}
//            , onPan: function(){}
//            , onUpdatedCTM: function(){}
//            , customEventsHandler: {}
//            , eventsListenerElement: null
    });

    initialZoom = svglandfill.getZoom();
    currentZoom = initialZoom;
}

function introMessage() {
  var intro = '' +
  '<div class="top-message">' +
		'<div class="top-message-carousel owl-carousel">' +
			'<div>' +
				'<div class="message-title">ΧΥΤΑ: Ένας «φιλόξενος χώρος» για όσα απορρίμματα απέμειναν…</div>' +
				'<div class="message-text">' +
                    '<p>Αναρωτήθηκες ποτέ πού καταλήγουν όσα υλικά θεωρούμε άχρηστα και τα πετάμε; ' +
                    'Με άλλα λόγια, πού καταλήγουν τα απορρίμματά μας; ' +
                    'Στην Ελλάδα σήμερα τα απορρίμματά μας οδηγούνται από τα απορριμματοφόρα σε κάποιον <strong>Χώρο Υγειονομικής Ταφής Απορριμμάτων</strong> ή πιο απλά <strong>ΧΥΤΑ.</strong></p>' +
                    '<p>Κάποιοι τον ονομάζουν <strong>Χώρο Υγειονομικής Ταφής Υπολειμμάτων (ΧΥΤΥ)</strong> για να μας υπενθυμίζουν ότι σ’ αυτόν πρέπει να καταλήγουν μόνο λίγα υπολείμματα. ' +
                    'Δηλαδή, όσα υλικά δεν καταφέραμε να χρησιμοποιήσουμε ξανά (ΕΠΑΝΑΧΡΗΣΙΜΟΠΟΙΗΣΗ), να ανακυκλώσουμε (ΑΝΑΚΥΚΛΩΣΗ) και να κομποστοποιήσουμε (ΚΟΜΠΟΣΤΟΠΟΙΗΣΗ).</p>' +
                    'Έχεις επισκεφτεί ποτέ <strong>ΧΥΤΑ;</strong> ' +
                    'Αν όχι, να η ευκαιρία! ' +
                    'Πού και πώς κατασκευάζεται; Πώς μοιάζει και πώς λειτουργεί ένας ΧΥΤΑ;' +
				'</div>' +
			'</div>' +
      '<div>' +
        '<div class="message-title">Πώς να περιηγηθείς στον ΧΥΤΑ...</div>' +
        '<div class="message-text">' +
                    'Για να περιηγηθείς στον ΧΥΤΑ μπορείς να κάνεις <strong>zoom</strong> με τη ροδέλα του ποντικιού σου, ' +
                    'έπειτα να κάνεις <strong>κλικ</strong> σε κάποιο σημείο του ΧΥΤΑ και να <strong>σύρεις το ποντίκι σου</strong> για να ' +
                    'μετακινήσεις το τμήμα του ΧΥΤΑ που φαίνεται στην οθόνη σου. ' +
                    'Επίσης μπορείς να χρησιμοποιήσεις τα εργαλεία μεγέθυνσης που υπάρχουν κάτω δεξιά στην οθόνη σου.' +
                    '<img style="margin-top: 20px;" src="images/navigation-controls.png">' +
        '</div>' +
      '</div>' +
      '<div>' +
        '<div class="message-title">Χρησιμοποίησε τις ενεργές περιοχές...</div>' +
        '<div class="message-text">' +
          '<p>Σε διάφορα σημεία του ΧΥΤΑ μπορείς να δεις <strong>κόκκινα κυκλάκια.</strong> Κάνοντας κλικ σε αυτά με το ποντίκι σου ' +
            'μπορείς να μάθεις πληροφορίες για το αντικείμενο πάνω στο οποίο βρίσκονται. Ξεκίνησε την εξερεύνηση κάνοντας ' +
            'κλικ σε μια από τις <strong>ενεργές περιοχές.</strong>' +
          '</p>' +
          '<p>' +
            'Αφού ανακαλύψεις όλα τα στοιχεία του ΧΥΤΑ σε περιμένει μια <strong>δραστηριότητα προβληματισμού...</strong>' +
          '</p>' +
          '<img style="margin-top: 20px;" src="images/hotspot.png">' +
        '</div>' +
      '</div>' +
      '<div>' +
        '<div class="message-title">Υπάρχουν ακόμη περισσότερες πληροφορίες για σένα...</div>' +
        '<div class="message-text">' +
          'Μπορείς να δεις βήμα - βήμα τη <strong>διαδικασία της κατασκευής</strong> ενός ΧΥΤΑ αλλά και τον <strong>τρόπο λειτουργίας του.</strong> ' +
          'Επάνω δεξιά στην οθόνη σου υπάρχουν τα βελάκια "<" (πίσω) και ">" (μπροστά). Μπορείς να τα χρησιμοποιήσεις ' +
          'για να πλοηγηθείς στο προηγούμενο ή επόμενο βήμα και να δεις άλλες ενεργές περιοχές στον ΧΥΤΑ.' +
          '<img style="margin-top: 20px;" src="images/top-controls.png">' +
        '</div>' +
        '</div>' +
		'</div>' +
		'<div class="button-prev is_hidden"><img src="assets/arrow-left-circle.svg"><div class="button-text">ΠΡΟΗΓΟΥΜΕΝΟ</div></div>' +
		'<div class="button-next"><div class="button-text">ΕΠΟΜΕΝΟ</div><img src="assets/arrow-right-circle.svg"></div>' +
	'</div>';

  $('.svg-container').append(intro);
}

function hotspotsHelp() {
    var help = ''+
    '<div class="top-message">' +
        '<div class="close-help"><img src="assets/close.svg"></div>' +
        '<div class="message-title">Άσε με να σε βοηθήσω...</div>' +
        '<div class="message-text">' +
            'Σε κάθε ερώτηση προβληματισμού θα πρέπει να βρεις ένα ή περισσότερα σημεία του ΧΥΤΑ τα οποία απαντούν στην ερώτηση. Το σημείο αυτό μπορεί να είναι είτε κάποια λειτουργία του είτε κάποιο χαρακτηριστικό του. ' +
            'Περνώντας το ποντίκι πάνω από το κάθε σημείο μπορείς να δεις τη περιγραφή του σημείου αυτού. Αυτό θα σε βοηθήσει να εντοπίσεις τη σωστή απάντηση.' +
            '<img style="margin-top: 20px; width: 100%;" src="images/hotspots-help.png">' +
        '</div>' +
    '</div>';

    $('.svg-container').append(help);
    $('.question-container').addClass('hidden');
    $('.close-help').click(function(){
        $('.top-message').remove();
        $('.question-container').removeClass('hidden');
    });
}

function agreeHelp() {
    var help = ''+
    '<div class="top-message">' +
        '<div class="close-help"><img src="assets/close.svg"></div>' +
        '<div class="message-title">Άσε με να σε βοηθήσω...</div>' +
        '<div class="message-text">' +
            'Στις ερωτήσεις αυτές θα πρέπει απλά να πεις τη γνώμη σου. Μη φοβάσαι, πες ελεύθερα αν συμφωνείς ή διαφωνείς με την φράση που βλέπεις. Δεν βαθμολογείσαι!' +
        '</div>' +
    '</div>';

    $('.svg-container').append(help);
    $('.question-container').addClass('hidden');
    $('.close-help').click(function(){
        $('.top-message').remove();
        $('.question-container').removeClass('hidden');
    });
}

function orderHelp() {
    var help = ''+
    '<div class="top-message">' +
        '<div class="close-help"><img src="assets/close.svg"></div>' +
        '<div class="message-title">Άσε με να σε βοηθήσω...</div>' +
        '<div class="message-text">' +
            'Αυτή είναι η τελευταία ερώτηση προβληματισμού. Αυτό που χρειάζεται είναι απλά να βάλεις στη σωστή σειρά τις τρεις ενέργειες, ξεκινώντας από την πιο κρίσιμη. Συμπλήρωσε στα γκρι πλαίσια τους αριθμούς 1, 2 και 3 για να ορίσεις τη σειρά των ενεργειών.' +
        '</div>' +
    '</div>';

    $('.svg-container').append(help);
    $('.question-container').addClass('hidden');
    $('.close-help').click(function(){
        $('.top-message').remove();
        $('.question-container').removeClass('hidden');
    });
}
